#ifndef __ACEncod_H
#define __ACEncod_H

//     (  range- .)

class ACEncoder
{ unsigned int code, range, FFNum, Cache;
  __int64 low; // Microsoft C/C++ 64-bit integer type

 public:
  ACEncoder () ;
  virtual ~ACEncoder () ;
  void StartEncode () ;
  void IncrementFrequency (unsigned int value) ;
  void BuildTable () ;
  void Encode (unsigned int value);
  void FinishEncode ();
  bool nayavnoCode;
  unsigned char *ehufsi ;   //     
  unsigned char *buffer;    //  
  unsigned int pozBuffer;
  unsigned char * bufFreq;  //       
  unsigned int pozBufFreq, pozBitFreq;
  unsigned int *freq;       //

 private:
  unsigned int *sumPprFreq; //  

  inline void ShiftLow();
  inline void putByte(unsigned char s);
};

class bitBufferOutput
{
 public:
  bitBufferOutput () ;
  virtual ~bitBufferOutput () ;
  void StartOutput() ;
  void OutputBit (unsigned int data, unsigned int length);

  unsigned char *buffer;    //  
  unsigned int pozBuffer, pozBitBuffer;
};

#endif
